drop function fsql_semantic_incluye_columnas_porciento (numeric(10),numeric(10),
							   varchar(100));
create function fsql_semantic_incluye_columnas_porciento (numeric(10),numeric(10),
							   varchar(100))
returns integer as '
declare
  columna_indice_entrada alias for $1;
  columna_posicion_entrada alias for $2;
  columna_nombre_entrada alias for $3;

  columna_indice numeric(10);
  columna_posicion numeric(10);
  columna_nombre varchar(100);

  token_sig   fsql_all_queries.nombre%type;
  talias      fsql_all_queries.nombre%type;
  inicio_from fsql_all_queries.indice%type;
  fin_from    fsql_all_queries.indice%type;
  ind         fsql_all_queries.indice%type;
  tsch   varchar(30);
  tabla record;
  audsid numeric;
  maxind_var numeric;
begin
  insert into trama values(nextval(''sec''),''fsql_semantic_incluye_columnas_porciento'');
  columna_indice = columna_indice_entrada;
  columna_posicion = columna_posicion_entrada;
  columna_nombre = columna_nombre_entrada;
  select into audsid pg_backend_pid();
  select into maxind_var maxind from variables;
  inicio_from:=columna_indice+1;

  fin_from:=inicio_from+1;
  loop
    select into token_sig nombre from fsql_all_queries where indice=fin_from;
    if not found then
	token_sig:=''fin'';
    end if;
    if token_sig in (''fin'','';'',''where'',''group'',''connect'',''start'',
                       ''union'',''intersect'',''minus'',''order'','')'') then
	exit;
    end if;
    fin_from:=fin_from+1;
  end loop;
  fin_from:=fin_from-1;

  ind:=columna_indice;
  update fsql_all_queries set (posicion,nombre,atributo)=
         (select posicion,nombre,atributo from fsql_all_queries where indice=ind-1)
         where indice=ind;
  update fsql_all_queries set atributo=null where indice=ind-1;

  for tabla in select indice,nombre,atributo from fsql_all_queries
                where  nombre like ''%tabla'' and
                       indice between inicio_from and fin_from loop

    select into talias nombre from fsql_all_queries
            where indice=tabla.indice+1+(ind-columna_indice);
    if not found then
	talias:=null;
    end if;
    if talias=''t_alias'' then
       select into tabla.atributo atributo from fsql_all_queries
         where indice=tabla.indice+1+(ind-columna_indice);
    end if;

    if tabla.nombre=''tabla'' then
       update fsql_all_queries set indice=indice+4
         where indice between ind+1 and maxind_var;
       insert into fsql_all_queries values (audsid,ind+1,0,''t.'',tabla.atributo);
       insert into fsql_all_queries values (audsid,ind+2,0,''.'',''.'');
       insert into fsql_all_queries values (audsid,ind+3,0,''t.%'',''%'');
       insert into fsql_all_queries values (audsid,ind+4,0,'', en sl'','','');
       ind:=ind+4;

       maxind_var:=maxind_var+4;
    else
       select into tsch atributo from fsql_all_queries
         where indice=tabla.indice-2+(ind-columna_indice);

       update fsql_all_queries set indice=indice+6
         where indice between ind+1 and maxind_var;
       insert into fsql_all_queries values (audsid,ind+1,0,''s.t.'',tsch);
       insert into fsql_all_queries values (audsid,ind+2,0,''.'',''.'');
       insert into fsql_all_queries values (audsid,ind+3,0,''t.'',tabla.atributo);
       insert into fsql_all_queries values (audsid,ind+4,0,''.'',''.'');
       insert into fsql_all_queries values (audsid,ind+5,0,''s.t.%'',''%'');
       insert into fsql_all_queries values (audsid,ind+6,0,'', en sl'','','');
       ind:=ind+6;
       maxind_var:=maxind_var+6;
    end if;
  end loop;

  update fsql_all_queries set atributo=null where indice=ind;
  update variables set maxind=maxind_var;
  return 0;
end;
'language 'plpgsql';
